#include <math.h> 
#include "tdf.h"
#include "io_mat.h"

main()
{
  MATFile *fout,*fin;
  float **sino;
  int   nr,ntheta;
  float **image;
  int   ht,wd;
  int   i,j,ii;
  struct system_matrix xform;


  fin = matOpen("trans1/test_in.mat", "r");
  if (fin == NULL) {
    fprintf(stderr,"Cannot read MatLab file \n");
    return(0);
  }
  sino = read_mat_float_image(&ntheta,&nr,"fsino",fin);
  close(fin);


  tdf_read_system_matrix(&xform, "trans1/xform.tdf");
  ht = xform.n_y;
  wd = xform.n_x;

  if( xform.Mpro!=(ntheta*nr) ) {
    fprintf(stderr, "\nInconsistant data\n");
    exit(-1);
  }

  image = (float **)multialloc(sizeof(float),2,ht,wd);
  for(i=0; i<ht; i++)
  for(j=0; j<wd; j++) {
    image[i][j] = 0.0;
  }

  /* backprojection */
  for(j=0; j<ht*wd; j++) {
    for(i=0; i<xform.n_row[j]; i++) {
      ii = xform.row[j][i];
      image[0][j] += xform.val[j][i]*sino[0][ii];
    }
  }
  destroy_system_matix(&xform);


  fout = matOpen("test_out.mat", "w");
  if (fout == NULL) {
    fprintf(stderr,"Cannot write to MatLab file\n");
    return(0);
  }

  write_mat_float_image(image,ht,wd,"img",fout);
  close(fout);

  return(0);
}



